#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "cell.h"
#include "rof.h"

using namespace std;

//֐̐錾difinition of the function
void read2DValueAsc(ROF** fROF, int n_year, int n_month, int ROFnum_row, int ROFnum_col);
void read2DValueBinary(ROF** fROF, int n_year, int n_month, int ROFnum_row, int ROFnum_col);
void read2DValueAscDaily(ROF** fROF, int n_year, int n_month, int ROFnum_row, int ROFnum_col);

int main()
{
	cout << "Reading parameters for runoff simulation." << endl;
	ifstream finParam("./param-averageRain.dat");
	if(!finParam){
		cout << "param-averageRain.dat cannot open." << endl;
		exit(1);
	}

	// vZ̈ simulation range
	cout << "1) Reading parameters for study area." << endl;

	int wCol,wRow;
	float wSWLON, wSWLAT;

	finParam >> wCol; 
	finParam >> wRow; 
	cout << "  Number of col : " << wCol << "  Number of row : " << wRow << endl;

	finParam >> wSWLON; 
	finParam >> wSWLAT;
	cout << " Sorth West corner Longitude (degree) : " << wSWLON 
		 << " Latitude (deg) : " << wSWLAT << endl;

	const int Col = wCol;     // column number of study area
	const int Row = wRow;     // row number of study area
	const float SWLON = wSWLON; // South west corner of longitude (degree)
	const float SWLAT = wSWLAT; // South west corner of latiitude (degree)

	// ̓f[^̈ input data range
	cout << "2) Reading parameters for input data." << endl;

	int wROFnum_col, wROFnum_row;
	double wDelta_x, wDelta_y, wROF_WLON, wROF_SLAT;
	finParam >> wROFnum_col;
	finParam >> wROFnum_row;
	cout << "  Number of col : " << wROFnum_col 
		 << "  Number of row : " << wROFnum_row << endl;

	finParam >> wDelta_x;
	finParam >> wDelta_y;
	cout << "  Input data grid size of x-direction : " << wDelta_x << endl;
	cout << "  Input data grid size of y-direction : " << wDelta_y << endl;

	finParam >> wROF_WLON; 
	cout << "  Longitude of the center of the Southwest corner of input data (degree) : " << wROF_WLON << endl;
	finParam >> wROF_SLAT; 
	cout << "  Latitude of the center of the Southwest corner of input data (degree) : " << wROF_SLAT << endl;
													
	const int ROFnum_col = wROFnum_col;
	const int ROFnum_row = wROFnum_row; 
	const float Delta_x = wDelta_x;
	const float Delta_y = wDelta_y;
	const float ROF_WLON = wROF_WLON;
	const float ROF_SLAT = wROF_SLAT;

	// ̓f[^̃tH[}bg the format of input data
	cout << "  the format number of input data." << endl;
	cout << "    1: Binary and hourly format" << endl;
	cout << "    2: Text and hourly format" << endl;
	cout << "    3: Text adn daily format" << endl;

	int wInputType;
	finParam >> wInputType;
	cout << "  Format number : " << wInputType << endl;
	const int InputType = wInputType;

	if(InputType!=1 && InputType!=2 && InputType!=3){
		cout << endl << "Error : a type of input data must be 1, 2 or 3." << endl;
		exit(1);
	}

	// vZ simulation term
	cout << "3) Reading parameters for simuration term." << endl;
	int wstartYear, wendYear, wstartMonth, wendMonth;
	finParam >> wstartYear;
	finParam >> wendYear;
	finParam >> wstartMonth;
	finParam >> wendMonth;
	cout << "  Start year : " << wstartYear << "  Start month : " << wstartMonth << endl;
	cout << "  End year : " << wendYear << "  End month : " << wendMonth << endl;

	const int startYear = wstartYear; // vZJnN start year
	const int endYear   = wendYear; // vZIN end year

	if (startYear > endYear) {
		cout << "Simulation year setting is wrong" << endl;
		exit(1);
	}

	const int startMonth = wstartMonth;   // vZJn start month
	const int endMonth   = wendMonth;  // vZI end month

	finParam.close();
	//--------------------- end parameter reading ------------------------------------------------

	//const int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};//varies in a loop year 2013/5/27 Tanaka


	/*--- ~Jf[^pӂ set input data information ---*/
	// Memory assignment for data cell of input data
	class ROF** rofObject;
	rofObject = new class ROF*[ROFnum_row];
	for(int i=0; i<ROFnum_row; i++){
		rofObject[i] = new class ROF[ROFnum_col];
	}
	/*--- ̓f[^IuWFNgɏ ---*/
	//eIuWFNgɈܓxEox
	float ROFlat, ROFlon;
	for(int i=0; i<ROFnum_row; i++){
		//ROFlat = ROF_SLAT + 0.5*Delta_y + i*Delta_y ;  // set latitude
		ROFlat = ROF_SLAT + i*Delta_y ;  // set latitude. Runoff grid is the center.
		for(int j=0; j<ROFnum_col; j++){
			//ROFlon = ROF_WLON +  0.5*Delta_x + j*Delta_x; // set longitude 
			ROFlon = ROF_WLON +  j*Delta_x; // set longitude  Runoff grid is the center.
			rofObject[i][j].setInformation(&ROFlat, &ROFlon);
		}
	}

	/*--- 敽ωJʂvZ闬ovZZpӂ set grid cell of simulation ---*/
	// Memory assignment for grid cell of simulation
	class Cell** cellObject; 
	cellObject = new class Cell*[Row];
	for(int i=0; i<Row; i++){
		cellObject[i] = new class Cell[Col];
	}
	/* latitude  longitude  longitudinalLength */
	FILE *fexBasin;
	//if(error = fopen_s(&fexBasin, "./topoData/extractBasin.bin", "rb") != NULL) {
	if ((fexBasin = fopen("./topoData/extractBasin.bin", "rb")) == NULL) {
		cout << "extractBasin.bin cannot open." << endl;
		exit(1);
	}

	for(int i=Row-1; i>=0; i--) { // DEM data arranges from south to north
		for(int j=0; j<Col; j++) {
			fread(&cellObject[i][j].riverKind, sizeof(int), 1, fexBasin);
			cellObject[i][j].setLocation(i, j, Row, Col, SWLAT, SWLON);
		}
	}
	fclose(fexBasin);


	/* connect cellObject and rofObject */
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			// extractBasinŎw肵ɑȂObhɂ false ݒ肷B 
			if(cellObject[i][j].riverKind != 1){
				continue;
			}

			cellObject[i][j].setROFCell(rofObject, ROFnum_row, ROFnum_col);
		}
	}


	//ʐςvZ.
	double area = 0.0;
	for(int m=0; m<Row; m++){
		for(int n=0; n<Col; n++){     // longitude direction from West
			// extractBasinŎw肵ɑȂObhɂ false ݒ肷B 
			if(cellObject[m][n].riverKind != 1){
				continue;
			}
			area += cellObject[m][n].longitudinalLength * 926.6;//[m^2]
		}
	}
	area *= 1.0e-6;//[m^2]-->[km^2]
	cout << "Basin area : " << area << " [km^2]" << endl;
	area *= 1.0e12;//[km^2]-->[mm^2]


	// --- ovZ runoff simulation ---
	cout << "Simulation starts from " << startYear << "/" << startMonth 
		<< " to " << endYear << "/" << endMonth << "." << endl;

	// count total number of month for simulation vZ鑍JEg
	int totalMonth;
/*
	if ((endYear-startYear) == 0) {
		totalMonth = endMonth-startMonth+1;
	}
	else if ((endYear-startYear) == 1) {
		totalMonth = 13-startMonth+endMonth;
	}
	else if ((endYear-startYear) >= 2) {
		//totalMonth = 13-startMonth+endMonth + (endYear-startYear)*12 ;//12HTanaka 2013/3/27
		totalMonth = 13-startMonth+endMonth + (endYear-startYear-1)*12 ;//Tanaka 2013/3/27
	}
*/
	// Corrected by S.J. Noh (17 Jan 2013)
	if ((endYear-startYear) < 0) {
	exit(1);
	}
	else {
		totalMonth = endMonth-startMonth+13+(endYear-startYear-1)*12 ;
	}

	cout << "Total simulation time is " << totalMonth << " months." << endl << endl; 
	

	int iyear = startYear;
	int imonth = startMonth;

	int wyear, wmonth, wday;

	for(int itotalMonth=0; itotalMonth < totalMonth; itotalMonth++) { // [v̊Jn

		iyear = startYear + (startMonth+itotalMonth-1)/12;
		imonth = (startMonth+itotalMonth-1)%12 + 1;

		cout << iyear << "/" << imonth << " ... calculating" << endl;
		if(imonth==2 && iyear%4==0) dayMonth[1]=29;// varies in a loop year
		else dayMonth[1]=28;// added 2014/12/3 Tanaka T.

		// --- ̓f[^̓ǂݍ read input data ---
		for(int i=0; i<ROFnum_row; i++){
			for(int j=0; j<ROFnum_col; j++){
				rofObject[i][j].initialize();
			}
		}
		// Use below line when reading two-dimensional input data 
		if(InputType==1){
			// Reading monthly input data with Grads format
			read2DValueBinary(rofObject, iyear, imonth, ROFnum_row, ROFnum_col);
		}
		else if(InputType==2){
			// 2 ksedge `̎ԉJʂ̃eLXgf[^ǂݍޏꍇɗpB
			read2DValueAsc(rofObject, iyear, imonth, ROFnum_row, ROFnum_col);
		}
		else if(InputType==3){
			// 2 ksedge `̓Jʂ̃eLXgf[^ǂݍޏꍇɗpB
			read2DValueAscDaily(rofObject, iyear, imonth, ROFnum_row, ROFnum_col);
		}
		else{//̃tH[}bgpӂɒǉĂD
		}

		//~ʂvZăt@Cɏo͂.
		ofstream FileRainfall; // Daily data
		char FileName[256];
		//sprintf_s(FileName, 256, "./output/dischargeHourly.bin");
		sprintf(FileName, "./output/%4d%02daveragedRain.dat", iyear, imonth);
		cout << "Write " << FileName << endl;
		FileRainfall.open(FileName, ios::out);
	
		double TotalRain = 0.0;
		for(int iday=1; iday<=dayMonth[imonth-1]; iday++){ // day loop
			for (int ihour=0; ihour < 24; ihour++) {
				for(int m=0; m<Row; m++){
					for(int n=0; n<Col; n++){     // longitude direction from West
						// extractBasinŎw肵ɑȂObhɂ false ݒ肷B 
						if(cellObject[m][n].riverKind != 1){
							continue;
						}
						TotalRain += cellObject[m][n].ROFCell->value[iday][ihour]
								* cellObject[m][n].longitudinalLength * 1000.0
								* 926.6 * 1000.0;//[mm^3]
					}
				}
			}
			TotalRain /= area;//[mm^3]-->[mm]
			FileRainfall << iday << " " << TotalRain << endl;
	
			TotalRain = 0.0;
		}
		FileRainfall.close();

	}


	for(int i=0; i<Row; i++){
		delete[] cellObject[i];
	}
	delete[] cellObject;


	return 0;
}


//	֐̒`
void read2DValueAsc(ROF** fROF, int n_year, int n_month, int ROFnum_row, int ROFnum_col)
{
	// read input data file arranged for two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/%04d%02d_rain.dat", n_year, n_month);
	sprintf(ROFfilename, "./input/%04d%02d_rain.dat", n_year, n_month);
	cout << ROFfilename << endl;
	cout << "Read " << ROFfilename << endl;

	ifstream fin(ROFfilename);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}

	//Ǒ̖̃f[^ value[0][ihour] ɃZbg
	//const int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};	
	int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};// varies in a loop year 2013/5/27 Tanaka
	if(n_month==2 && n_year%4==0) dayMonth[1]=29;// varies in a loop year

	int c_month;
	c_month = n_month - 1;
	if(c_month == 0){
		c_month = c_month + 12;
	}

	// O̍ŏI̎ԗʂ0ڂ̎ԗʂɃZbg
	for(int i=0; i<ROFnum_row; i++){
		for(int j=0; j<ROFnum_col; j++){		
			for(int ihour=0; ihour<24; ihour++){
				fROF[i][j].value[0][ihour] = fROF[i][j].value[dayMonth[c_month-1]][ihour];
			}
		}
	}

	// read one month data. 1̎ԃf[^ǂݍ
	int year, month, day, hour, xcol, yrow;
	for(int iday=1; iday <= dayMonth[n_month-1]; iday++){  // day loop
		for(int ihour=0; ihour<24; ihour++){ // hour loop
			fin >> year >> month >> day >> hour >> xcol >> yrow; // read header for each hour
			//ӁF~Jf[^̓vOœ삩i[
			for(int i=ROFnum_row-1; i>=0; i--){ // 1st row data is the northest row!
				for(int j=0; j<ROFnum_col; j++){ // 1st column is the westest column!
					fin >> fROF[i][j].value[iday][ihour] ;
				}
			}
		}
	}

	fin.close();
}

//	֐̒`
void read2DValueBinary(ROF** fROF, int n_year, int n_month, int ROFnum_row, int ROFnum_col)
{
	// read input data file arranged for two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/%04d%02d_rain.bin", n_year, n_month);
	sprintf(ROFfilename, "./input/%04d%02d_rain.bin", n_year, n_month);
	cout << ROFfilename << endl;
	cout << "Read " << ROFfilename << endl;

	ifstream fin(ROFfilename, ios::in | ios::binary);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}

	//Ǒ̖̃f[^ value[0][ihour] ɃZbg
	int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};	
	if(n_month==2 && n_year%4==0) dayMonth[1]=29;// varies in a loop year

	int c_month;
	c_month = n_month - 1;
	if(c_month == 0){
		c_month = c_month + 12;
	}

	// O̍ŏI̎ԗʂ0ڂ̎ԗʂɃZbg
	for(int i=0; i<ROFnum_row; i++){
		for(int j=0; j<ROFnum_col; j++){		
			for(int ihour=0; ihour<24; ihour++){
				fROF[i][j].value[0][ihour] = fROF[i][j].value[dayMonth[c_month-1]][ihour];
			}
		}
	}

	// read one month data. 1̎ԃf[^ǂݍ
	float rain;
	for(int iday=1; iday <= dayMonth[n_month-1]; iday++){  // day loop
		for(int ihour=0; ihour<24; ihour++){  // hour loop
			//ӁF~Jf[^̓vOœ삩i[
//			for(int i=ROFnum_row-1; i>=0; i--){//Textf[^͖k
			for(int i=0; i<ROFnum_row; i++){//Binaryf[^͓삩
				for(int j=0; j<ROFnum_col; j++){  // 1st column is the westest column!
					fin.read((char*)&rain, sizeof(float));
					fROF[i][j].value[iday][ihour] = rain;
				}
			}
		}
	}

	fin.close();
}

void read2DValueAscDaily(ROF** fROF, int n_year, int n_month, int ROFnum_row, int ROFnum_col)
{
	// read ascii format two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/%04d%02d_rain.dat", n_year, n_month);
	//sprintf(ROFfilename, "./input/%04d%02d_rain.dat", n_year, n_month);
	sprintf(ROFfilename, "./input/%04d%02d_rain.dat", n_year, n_month);
	cout << ROFfilename << endl;

	ifstream fin(ROFfilename);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}

	//Ǒ̖̃f[^ value[0][ihour] ɃZbg
	//const int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};	
	int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};// varies in a loop year 2013/5/27 Tanaka
	if(n_month==2 && n_year%4==0) dayMonth[1]=29;// varies in a loop year

	int c_month;
	c_month = n_month - 1;
	if(c_month == 0){
		c_month = c_month + 12;
	}

	// O̍ŏI̎ԗʂ0ڂ̎ԗʂɃZbg
	for(int i=0; i<ROFnum_row; i++){
		for(int j=0; j<ROFnum_col; j++){		
			for(int ihour=0; ihour<24; ihour++){
				fROF[i][j].value[0][ihour] = fROF[i][j].value[dayMonth[c_month-1]][ihour];
			}
		}
	}

	// read one month data. 1̎ԃf[^ǂݍ
	int year, month, day, hour, xcol, yrow;
	float rainDaily;

	for(int iday=1; iday <= dayMonth[n_month-1]; iday++){  // day loop
		fin >> year >> month >> day >> hour >> xcol >> yrow;
		//ӁF~Jf[^̓vOœ삩i[
		for(int i=ROFnum_row-1; i>=0; i--){
			for(int j=0; j<ROFnum_col; j++){
				fin >> rainDaily;
				for(int ihour=0; ihour<24; ihour++){
					fROF[i][j].value[iday][ihour] = rainDaily/24.0;
				}
			}
		}
	}

	fin.close();
} 

